using System;
using System.ComponentModel;
using System.Collections;
using Borland.Eco.Services;
using Borland.Eco.ObjectRepresentation;
using Borland.Eco.ObjectImplementation;
using Borland.Eco.UmlRt;
using Borland.Eco.UmlCodeAttributes;


namespace ProjectECO1
{
	[UmlElement("Package")]
	[UmlMetaAttribute("ownedElement", typeof(Employee))]
	[UmlMetaAttribute("ownedElement", typeof(Person))]
	[UmlMetaAttribute("ownedElement", typeof(Company))]
	public abstract class CoreClassesPackage
	{
		
		[UmlElement("Association")]
		public class worksfor
		{
		}
	}
	[UmlElement]
	public class Employee : Person
	{
		
		[UmlCollection(typeof(Employee))][EcoAutoGenerated]
		public interface IEmployeeList
		{
			
			Employee this[int index] {get; set;}
			int Count
			{
				get;
			}
			
			void Clear();
			
			void RemoveAt(int index);
			
			int Add(Employee value);
			
			bool Contains(Employee value);
			
			int IndexOf(Employee value);
			
			EmployeeListAdapter.EmployeeEnumerator GetEnumerator();
			
			void Insert(int index, Employee value);
			
			void Remove(Employee value);
		}
		
		[EcoAutoGenerated]
		public class EmployeeListAdapter : PersonListAdapter, IEmployeeList
		{
			
			new public Employee this[int index] {get {return (Employee)Adaptee[index];} set {Adaptee[index] = value;}}
			public EmployeeListAdapter(IList source) : 
					base(source)
			{
			}
			
			public virtual int Add(Employee value)
			{
				return this.Adaptee.Add(value);
			}
			
			public virtual bool Contains(Employee value)
			{
				return this.Adaptee.Contains(value);
			}
			
			public virtual int IndexOf(Employee value)
			{
				return this.Adaptee.IndexOf(value);
			}
			
			public virtual void Insert(int index, Employee value)
			{
				this.Adaptee.Insert(index, value);
			}
			
			public virtual void Remove(Employee value)
			{
				this.Adaptee.Remove(value);
			}
			
			public new virtual EmployeeEnumerator GetEnumerator()
			{
				return new EmployeeEnumerator(this);
			}
			
			public class EmployeeEnumerator
			{
				
				private EmployeeListAdapter adapter;
				
				private int currentIndex = -1;
				
				public EmployeeEnumerator(EmployeeListAdapter adapter)
				{
					this.adapter = adapter;
				}
				
				public virtual Employee Current
				{
					get
					{
						return this.adapter[this.currentIndex];
					}
				}
				
				public virtual bool MoveNext()
				{
					int count = -1;
					if ((this.currentIndex < count))
					{
						this.currentIndex = (this.currentIndex + 1);
						return (this.currentIndex < count);
					} else
					{
						throw new InvalidOperationException();
					}
				}
			}
		}
		
		#region Autogenerated ECO code
		
		[EcoAutoGenerated]
		public Employee(IContent content) : 
				base(content)
		{
		}
		[EcoAutoGenerated]
		protected const int EmployeeFirstMember = PersonMemberCount;
		[EcoAutoGenerated]
		protected const int EmployeeMemberCount = (EmployeeFirstMember + 2);
		
		[EcoAutoGenerated]
		protected int _EmployeeNumber
		{
			get
			{
				return ((int)(this._content.get_MemberByIndex((EmployeeFirstMember + 0))));
			}
			set
			{
				this._content.set_MemberByIndex((EmployeeFirstMember + 0), value);
			}
		}
		
		[EcoAutoGenerated]
		protected IList _Company
		{
			get
			{
				return ((IList)(this._content.get_MemberByIndex((EmployeeFirstMember + 1))));
			}
		}
		
		[EcoAutoGenerated]
		public override object get_MemberByIndex(int index)
		{
			switch(index)
            {
                case EmployeeFirstMember+0:
                      return EmployeeNumber;
                case EmployeeFirstMember+1:
                      return Company;
                default:
                    return base.get_MemberByIndex(index);
            }

		}
		
		[EcoAutoGenerated]
		public override void set_MemberByIndex(int index, object value)
		{
			switch(index)
            {
                case EmployeeFirstMember+0:
                    EmployeeNumber = (int)value;
                    break;
                default:
                    base.set_MemberByIndex(index, value);
                    break;
            }

		}
		
		#endregion Autogenerated ECO code
		
		[EcoAutoMaintained]
		public Employee(IEcoServiceProvider serviceProvider) : 
				base(serviceProvider)
		{
			try
			{
				// user code here
			} catch (System.Exception e)
			{
				this.Deinitialize(serviceProvider);
				throw e;
			}
		}
		[UmlElement(Index=(EmployeeFirstMember + 0))]
		[EcoAutoMaintained]
		public int EmployeeNumber
		{
			get
			{
				// If you add user code here, please remove the [EcoAutoMaintained] attribute
				return this._EmployeeNumber;
			}
			set
			{
				// If you add user code here, please remove the [EcoAutoMaintained] attribute
				this._EmployeeNumber = value;
				// If you add user code here, please remove the [EcoAutoMaintained] attribute
			}
		}
		[UmlElement(Index=(EmployeeFirstMember + 1))]
		[EcoAutoMaintained]
		[UmlMetaAttribute("association", typeof(CoreClassesPackage.worksfor), Index=1)]
		[UmlMetaAttribute("multiplicity", "1..*")]
		public Company.ICompanyList Company
		{
			get
			{
				// If you add user code here, please remove the [EcoAutoMaintained] attribute
				return new Company.CompanyListAdapter(this._Company);
			}
		}
	}
	[UmlElement]
	public class Person : ILoopBack
	{
		
		[UmlCollection(typeof(Person))][EcoAutoGenerated]
		public interface IPersonList
		{
			
			Person this[int index] {get; set;}
			int Count
			{
				get;
			}
			
			void Clear();
			
			void RemoveAt(int index);
			
			int Add(Person value);
			
			bool Contains(Person value);
			
			int IndexOf(Person value);
			
			PersonListAdapter.PersonEnumerator GetEnumerator();
			
			void Insert(int index, Person value);
			
			void Remove(Person value);
		}
		
		[EcoAutoGenerated]
		public class PersonListAdapter : ObjectListAdapter, IPersonList
		{
			
			public Person this[int index] {get {return (Person)Adaptee[index];} set {Adaptee[index] = value;}}
			public PersonListAdapter(IList source) : 
					base(source)
			{
			}
			
			public virtual int Add(Person value)
			{
				return this.Adaptee.Add(value);
			}
			
			public virtual bool Contains(Person value)
			{
				return this.Adaptee.Contains(value);
			}
			
			public virtual int IndexOf(Person value)
			{
				return this.Adaptee.IndexOf(value);
			}
			
			public virtual void Insert(int index, Person value)
			{
				this.Adaptee.Insert(index, value);
			}
			
			public virtual void Remove(Person value)
			{
				this.Adaptee.Remove(value);
			}
			
			public virtual PersonEnumerator GetEnumerator()
			{
				return new PersonEnumerator(this);
			}
			
			public class PersonEnumerator
			{
				
				private PersonListAdapter adapter;
				
				private int currentIndex = -1;
				
				public PersonEnumerator(PersonListAdapter adapter)
				{
					this.adapter = adapter;
				}
				
				public virtual Person Current
				{
					get
					{
						return this.adapter[this.currentIndex];
					}
				}
				
				public virtual bool MoveNext()
				{
					int count = -1;
					if ((this.currentIndex < count))
					{
						this.currentIndex = (this.currentIndex + 1);
						return (this.currentIndex < count);
					} else
					{
						throw new InvalidOperationException();
					}
				}
			}
		}
		
		#region Autogenerated ECO code
		
		[EcoAutoGenerated]
		public IObject AsIObject()
		{
			return this._content.AsIObject();
		}
		[EcoAutoGenerated]
		protected IContent _content;
		
		[EcoAutoGenerated]
		public Person(IContent content)
		{
			this._content = content;
		}
		[EcoAutoGenerated]
		protected const int PersonFirstMember = 0;
		[EcoAutoGenerated]
		protected const int PersonMemberCount = (PersonFirstMember + 2);
		
		[EcoAutoGenerated]
		protected string _FirstName
		{
			get
			{
				return ((string)(this._content.get_MemberByIndex((PersonFirstMember + 0))));
			}
			set
			{
				this._content.set_MemberByIndex((PersonFirstMember + 0), value);
			}
		}
		
		[EcoAutoGenerated]
		protected string _LastName
		{
			get
			{
				return ((string)(this._content.get_MemberByIndex((PersonFirstMember + 1))));
			}
			set
			{
				this._content.set_MemberByIndex((PersonFirstMember + 1), value);
			}
		}
		
		[EcoAutoGenerated]
		public virtual object get_MemberByIndex(int index)
		{
			switch(index)
            {
                case PersonFirstMember+0:
                      return FirstName;
                case PersonFirstMember+1:
                      return LastName;
                default:
                    throw new Exception();
            }

		}
		
		[EcoAutoGenerated]
		public virtual void set_MemberByIndex(int index, object value)
		{
			switch(index)
            {
                case PersonFirstMember+0:
                    FirstName = (string)value;
                    break;
                case PersonFirstMember+1:
                    LastName = (string)value;
                    break;
                default:
                    throw new Exception();
            }

		}
		
		[EcoAutoGenerated]
		protected void Initialize(IEcoServiceProvider serviceProvider)
		{
			if ((this._content == null))
			{
				IInternalObjectContentFactory factory = ((IInternalObjectContentFactory)(serviceProvider.GetEcoService(typeof(IInternalObjectContentFactory))));
				this._content = factory.CreateContent(this);
			}
		}
		
		[EcoAutoGenerated]
		protected void Deinitialize(IEcoServiceProvider serviceProvider)
		{
			if ((this._content != null))
			{
				IInternalObjectContentFactory factory = ((IInternalObjectContentFactory)(serviceProvider.GetEcoService(typeof(IInternalObjectContentFactory))));
				factory.CreateContentFailed(this._content, this);
				this._content = null;
			}
		}
		
		#endregion Autogenerated ECO code
		
		[EcoAutoMaintained]
		public Person(IEcoServiceProvider serviceProvider)
		{
			this.Initialize(serviceProvider);
			try
			{
				// user code here
			} catch (System.Exception e)
			{
				this.Deinitialize(serviceProvider);
				throw e;
			}
		}
		[UmlElement(Index=(PersonFirstMember + 0))]
		[EcoAutoMaintained]
		public string FirstName
		{
			get
			{
				// If you add user code here, please remove the [EcoAutoMaintained] attribute
				return this._FirstName;
			}
			set
			{
				// If you add user code here, please remove the [EcoAutoMaintained] attribute
				this._FirstName = value;
				// If you add user code here, please remove the [EcoAutoMaintained] attribute
			}
		}
		[UmlElement(Index=(PersonFirstMember + 1))]
		[EcoAutoMaintained]
		public string LastName
		{
			get
			{
				// If you add user code here, please remove the [EcoAutoMaintained] attribute
				return this._LastName;
			}
			set
			{
				// If you add user code here, please remove the [EcoAutoMaintained] attribute
				this._LastName = value;
				// If you add user code here, please remove the [EcoAutoMaintained] attribute
			}
		}
	}
	[UmlElement]
	public class Company : ILoopBack
	{
		
		[UmlCollection(typeof(Company))][EcoAutoGenerated]
		public interface ICompanyList
		{
			
			Company this[int index] {get; set;}
			int Count
			{
				get;
			}
			
			void Clear();
			
			void RemoveAt(int index);
			
			int Add(Company value);
			
			bool Contains(Company value);
			
			int IndexOf(Company value);
			
			CompanyListAdapter.CompanyEnumerator GetEnumerator();
			
			void Insert(int index, Company value);
			
			void Remove(Company value);
		}
		
		[EcoAutoGenerated]
		public class CompanyListAdapter : ObjectListAdapter, ICompanyList
		{
			
			public Company this[int index] {get {return (Company)Adaptee[index];} set {Adaptee[index] = value;}}
			public CompanyListAdapter(IList source) : 
					base(source)
			{
			}
			
			public virtual int Add(Company value)
			{
				return this.Adaptee.Add(value);
			}
			
			public virtual bool Contains(Company value)
			{
				return this.Adaptee.Contains(value);
			}
			
			public virtual int IndexOf(Company value)
			{
				return this.Adaptee.IndexOf(value);
			}
			
			public virtual void Insert(int index, Company value)
			{
				this.Adaptee.Insert(index, value);
			}
			
			public virtual void Remove(Company value)
			{
				this.Adaptee.Remove(value);
			}
			
			public virtual CompanyEnumerator GetEnumerator()
			{
				return new CompanyEnumerator(this);
			}
			
			public class CompanyEnumerator
			{
				
				private CompanyListAdapter adapter;
				
				private int currentIndex = -1;
				
				public CompanyEnumerator(CompanyListAdapter adapter)
				{
					this.adapter = adapter;
				}
				
				public virtual Company Current
				{
					get
					{
						return this.adapter[this.currentIndex];
					}
				}
				
				public virtual bool MoveNext()
				{
					int count = -1;
					if ((this.currentIndex < count))
					{
						this.currentIndex = (this.currentIndex + 1);
						return (this.currentIndex < count);
					} else
					{
						throw new InvalidOperationException();
					}
				}
			}
		}
		
		#region Autogenerated ECO code
		
		[EcoAutoGenerated]
		public IObject AsIObject()
		{
			return this._content.AsIObject();
		}
		[EcoAutoGenerated]
		protected IContent _content;
		
		[EcoAutoGenerated]
		public Company(IContent content)
		{
			this._content = content;
		}
		[EcoAutoGenerated]
		protected const int CompanyFirstMember = 0;
		[EcoAutoGenerated]
		protected const int CompanyMemberCount = (CompanyFirstMember + 2);
		
		[EcoAutoGenerated]
		protected string _Name
		{
			get
			{
				return ((string)(this._content.get_MemberByIndex((CompanyFirstMember + 0))));
			}
			set
			{
				this._content.set_MemberByIndex((CompanyFirstMember + 0), value);
			}
		}
		
		[EcoAutoGenerated]
		protected Employee _Employee
		{
			get
			{
				return ((Employee)(this._content.get_MemberByIndex((CompanyFirstMember + 1))));
			}
			set
			{
				this._content.set_MemberByIndex((CompanyFirstMember + 1), value);
			}
		}
		
		[EcoAutoGenerated]
		public virtual object get_MemberByIndex(int index)
		{
			switch(index)
            {
                case CompanyFirstMember+0:
                      return Name;
                case CompanyFirstMember+1:
                      return Employee;
                default:
                    throw new Exception();
            }

		}
		
		[EcoAutoGenerated]
		public virtual void set_MemberByIndex(int index, object value)
		{
			switch(index)
            {
                case CompanyFirstMember+0:
                    Name = (string)value;
                    break;
                case CompanyFirstMember+1:
                    Employee = (Employee)value;
                    break;
                default:
                    throw new Exception();
            }

		}
		
		[EcoAutoGenerated]
		protected void Initialize(IEcoServiceProvider serviceProvider)
		{
			if ((this._content == null))
			{
				IInternalObjectContentFactory factory = ((IInternalObjectContentFactory)(serviceProvider.GetEcoService(typeof(IInternalObjectContentFactory))));
				this._content = factory.CreateContent(this);
			}
		}
		
		[EcoAutoGenerated]
		protected void Deinitialize(IEcoServiceProvider serviceProvider)
		{
			if ((this._content != null))
			{
				IInternalObjectContentFactory factory = ((IInternalObjectContentFactory)(serviceProvider.GetEcoService(typeof(IInternalObjectContentFactory))));
				factory.CreateContentFailed(this._content, this);
				this._content = null;
			}
		}
		
		#endregion Autogenerated ECO code
		
		[EcoAutoMaintained]
		public Company(IEcoServiceProvider serviceProvider)
		{
			this.Initialize(serviceProvider);
			try
			{
				// user code here
			} catch (System.Exception e)
			{
				this.Deinitialize(serviceProvider);
				throw e;
			}
		}
		[UmlElement(Index=(CompanyFirstMember + 0))]
		[EcoAutoMaintained]
		public string Name
		{
			get
			{
				// If you add user code here, please remove the [EcoAutoMaintained] attribute
				return this._Name;
			}
			set
			{
				// If you add user code here, please remove the [EcoAutoMaintained] attribute
				this._Name = value;
				// If you add user code here, please remove the [EcoAutoMaintained] attribute
			}
		}
		[UmlElement(Index=(CompanyFirstMember + 1))]
		[EcoAutoMaintained]
		[UmlMetaAttribute("association", typeof(CoreClassesPackage.worksfor), Index=0)]
		[UmlMetaAttribute("multiplicity", "0..1")]
		public Employee Employee
		{
			get
			{
				// If you add user code here, please remove the [EcoAutoMaintained] attribute
				return this._Employee;
			}
			set
			{
				this._Employee = value;
			}
		}
	}
}
