using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;
using System.Data;

namespace ProjectECO2
{
	/// <summary>
	/// Summary description for WinForm.
	/// </summary>
	public class WinForm : System.Windows.Forms.Form
	{
		/// <summary>
		/// Required designer variable.
		/// </summary>
		private System.ComponentModel.Container components = null;
		private Borland.Eco.Handles.ReferenceHandle rhRoot;
		private ProjectECO2EcoSpace ecoSpace;
    private System.Windows.Forms.Button button1;
    private System.Windows.Forms.Button button2;
    private System.Windows.Forms.Button button3;
		public ProjectECO2EcoSpace EcoSpace {
			get { 
				if (ecoSpace == null)
				{
					ecoSpace = new ProjectECO2EcoSpace();
					rhRoot.EcoSpace = ecoSpace;
				}
				return ecoSpace;
			}
		}

		public WinForm()
		{
			//
			// Required for Windows Form Designer support
			//
			InitializeComponent();
			// The line below will automatically activate the ECO Space.
			// Remove the line if you need to perform any initialization
			// before activating the ECO Space
			EcoSpace.Active = true;
			//
			// TODO: Add any constructor code after InitializeComponent call
			//
		}

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose (bool disposing)
		{
			if (disposing)
			{
				if (components != null)
				{
					components.Dispose();
				}
			}
			base.Dispose(disposing);
		}

		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
    {
      this.rhRoot = new Borland.Eco.Handles.ReferenceHandle();
      this.button1 = new System.Windows.Forms.Button();
      this.button2 = new System.Windows.Forms.Button();
      this.button3 = new System.Windows.Forms.Button();
      this.SuspendLayout();
      // 
      // rhRoot
      // 
      this.rhRoot.EcoSpace = null;
      this.rhRoot.EcoSpaceType = null;
      this.rhRoot.StaticValueTypeName = "";
      this.rhRoot.Variables = null;
      // 
      // button1
      // 
      this.button1.Location = new System.Drawing.Point(32, 32);
      this.button1.Name = "button1";
      this.button1.TabIndex = 0;
      this.button1.Text = "create";
      this.button1.Click += new System.EventHandler(this.button1_Click);
      // 
      // button2
      // 
      this.button2.Location = new System.Drawing.Point(32, 88);
      this.button2.Name = "button2";
      this.button2.TabIndex = 1;
      this.button2.Text = "ECO Space";
      this.button2.Click += new System.EventHandler(this.button2_Click);
      // 
      // button3
      // 
      this.button3.Location = new System.Drawing.Point(56, 176);
      this.button3.Name = "button3";
      this.button3.TabIndex = 2;
      this.button3.Text = "button3";
      this.button3.Click += new System.EventHandler(this.button3_Click);
      // 
      // WinForm
      // 
      this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
      this.ClientSize = new System.Drawing.Size(292, 266);
      this.Controls.Add(this.button3);
      this.Controls.Add(this.button2);
      this.Controls.Add(this.button1);
      this.Name = "WinForm";
      this.Text = "WinForm";
      this.ResumeLayout(false);
    }
		#endregion

		/// <summary>
		/// The main entry point for the application.
		/// </summary>
		[STAThread]
		static void Main() 
		{
			Application.Run(new WinForm());
		}
    
    private void button1_Click(object sender, System.EventArgs e)
    {
      Company comp = new Company(EcoSpace);
      comp.Name = "Borland";

      Employee emp = new Employee(EcoSpace);
      emp.FirstName = "Micha";
      emp.LastName = "Somers";
      emp.worksfor = comp;

      emp = new Employee(EcoSpace);
      emp.FirstName = "John";
      emp.LastName = "Kaster";
      emp.worksfor = comp;

      comp = new Company(EcoSpace);
      comp.Name = "Bob Swart Training & Consultancy";

      emp = new Employee(EcoSpace);
      emp.FirstName = "Bob";
      emp.LastName = "Swart";
      emp.worksfor = comp;
      emp.SayHello();

      EcoSpace.UpdateDatabase();
      
    }
    
    private void button2_Click(object sender, System.EventArgs e)
    {
      EcoWinForm form = new EcoWinForm(EcoSpace);
      form.Show();
    }

    private void button3_Click(object sender, System.EventArgs e)
    {
//    EcoSpace.
    }
	}
}
